
var DELETE_TIME = 6000;
var MAX_FEATURES = 100;
var overlay;

function deleteOld() {
    if (overlay.features.length > MAX_FEATURES) {
        var toRemove = overlay.features.length - MAX_FEATURES;
        var rmFeatures = overlay.features.slice(0, toRemove);
        overlay.removeFeatures(rmFeatures);
    }
    setTimeout(deleteOld, DELETE_TIME);
}

function startUp() {
    var myLocation = new OpenLayers.Geometry.Point(100, 0).transform('EPSG:4326', 'EPSG:3857');
    overlay = new OpenLayers.Layer.Vector('Points', {
        styleMap: new OpenLayers.StyleMap({
            pointRadius: '1',
            fillColor: '#ffffff',
            strokeColor: '#ff0000',
            strokeWidth: '1px',
            fillOpacity: '0.3'
        })
    });

    var map = new OpenLayers.Map({
        div: 'map',
        layers: [new OpenLayers.Layer.OSM(), overlay],
        center: myLocation.getBounds().getCenterLonLat(),
        zoom: 2
    });

    setTimeout(deleteOld, DELETE_TIME);
}


var source = new EventSource('/events');
source.onmessage = function(event) {
    var data = JSON.parse(event.data);
    var feature = new OpenLayers.Feature.Vector(
        new OpenLayers.Geometry.Point(
            data.lng,data.lat)
                .transform('EPSG:4326', 'EPSG:3857'));
    overlay.addFeatures([feature]);
    var svg = document.getElementById(feature.geometry.id);
    if (svg) {
        var ani = document.createElementNS('http://www.w3.org/2000/svg', 'animate');
        ani.setAttribute('attributeName', 'r');
        ani.setAttribute('begin','DOMNodeInserted');
        ani.setAttribute('dur', '0.7s');
        ani.setAttribute('from', '20');
        ani.setAttribute('to','1');
        svg.appendChild(ani);
    }
};
